@echo off & setlocal enableextensions

echo Ŀ
echo  NAMEUP.CMD Covert a filename to upper case 
echo  By Prof. Timo Salmi                        
echo  Last modified Mon 2-May-2005               
echo 
echo.

rem Converts also the Scandinavian characters
rem   --    --    -- 
rem If you do not want that customize the ToUpcase subroutine

:: Usage
if [%1]==[] (
  echo Usage: "%~f0" "FileName.Ext"
  echo.
  echo For wildcards use e.g.
  echo "for %%f in (*.txt) do call nameup %%f"
  if not defined cmdbox if defined PauseIfFromDesktop pause
  goto :EOF)

:: Don't allow wildcards
echo "%1"|findstr "[*?]">nul
if %errorlevel% EQU 0 (
  echo Wildcards not allowed in %1
  echo.
  echo Apply e.g.
  echo.for %%f in ^(*.*^) ^do nameup %%f
  echo.for %%f in ^(*.doc^) ^do nameup %%f
  echo.for %%f in ^(*.htm^) ^do nameup %%f
  echo.for %%f in ^(*.mai^) ^do nameup %%f
  echo.for %%f in ^(*.pgp^) ^do nameup %%f
  echo.for %%f in ^(*.rtf^) ^do nameup %%f
  echo.for %%f in ^(*.txt^) ^do nameup %%f
  goto :EOF)

:: Test for LFN peculiarities
if not [%2]==[] (
  echo A file name with spaces in it should be enclosed in parentheses ""
  goto :EOF)

:: Check that the file exists
if not exist "%~f1" (
  echo File %~f1 not found
  goto :EOF)

:: Get the file's parts
set fullname_=%~f1
set name_=%~n1
set ext_=%~x1

:: Covert to upper case
call :ToUpcase "%name_%" name_
call :ToUpcase "%ext_%" ext_

:: Ask for confirmation
set ask_=
echo Convert "%fullname_%" to "%name_%%ext_%"
set /p ask_="are you sure [N/y]?"
if /i not "%ask_%"=="y" goto :EOF
set ask_=

:: Do the conversion
ren "%fullname_%" "%name_%%ext_%"
echo.
dir "%fullname_%"

if not defined cmdbox if defined PauseIfFromDesktop pause

endlocal & goto :EOF

:: ====================================================================
:ToUpcase
setlocal enableextensions
set var_=%1
set var_=%var_:a=A%
set var_=%var_:b=B%
set var_=%var_:c=C%
set var_=%var_:d=D%
set var_=%var_:e=E%
set var_=%var_:f=F%
set var_=%var_:g=G%
set var_=%var_:h=H%
set var_=%var_:i=I%
set var_=%var_:j=J%
set var_=%var_:k=K%
set var_=%var_:l=L%
set var_=%var_:m=M%
set var_=%var_:n=N%
set var_=%var_:o=O%
set var_=%var_:p=P%
set var_=%var_:q=Q%
set var_=%var_:r=R%
set var_=%var_:s=S%
set var_=%var_:t=T%
set var_=%var_:u=U%
set var_=%var_:v=V%
set var_=%var_:w=W%
set var_=%var_:x=X%
set var_=%var_:y=Y%
set var_=%var_:z=Z%
set var_=%var_:=%
set var_=%var_:=%
set var_=%var_:=%
set var_=%var_:"=%
endlocal & set %2=%var_%& goto :EOF
